Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 171522)
+++ channels/chan_sip.c	(working copy)
@@ -1815,6 +1815,7 @@
 	/* z9hG4bK is a magic cookie.  See RFC 3261 section 8.1.1.7 */
 	ast_string_field_build(p, via, "SIP/2.0/UDP %s:%d;branch=z9hG4bK%08x%s",
 			       ast_inet_ntoa(p->ourip), ourport, (int) p->branch, rport);
+	ast_log(LOG_DEBUG, "####### Building VIA header %s - Branch is %d\n", p->via, (int) p->branch);
 }
 
 /*! \brief NAT fix - decide which IP address to use for ASterisk server?
@@ -4528,6 +4529,7 @@
 	ast_set2_flag(&p->flags[0], !recordhistory, SIP_NO_HISTORY);
 
 	p->branch = ast_random();	
+	ast_log(LOG_DEBUG, "######### GENERATING NEW BRANCH TAG for call %s\n", callid ? callid : "--");
 	make_our_tag(p->tag, sizeof(p->tag));
 	p->ocseq = INITIAL_CSEQ;
 
@@ -6032,6 +6034,7 @@
 	const char *ot, *of;
 	int is_strict = FALSE;		/*!< Strict routing flag */
 
+	ast_log(LOG_DEBUG, "######## reqprep newbranch %d sip_method %s\n", newbranch, sip_methods[sipmethod].text);
 	memset(req, 0, sizeof(struct sip_request));
 	
 	snprintf(p->lastmsg, sizeof(p->lastmsg), "Tx: %s", sip_methods[sipmethod].text);
@@ -6043,9 +6046,11 @@
 	
 	if (sipmethod == SIP_CANCEL) {
 		p->branch = p->invite_branch;
+		ast_log(LOG_DEBUG, "##### Copying INVITE BRANCH TAG for CANCEL call %s\n", p->callid);
 		build_via(p);
 	} else if (newbranch) {
 		p->branch ^= ast_random();
+		ast_log(LOG_DEBUG, "##### GENERATING NEW BRANCH TAG for call %s\n", p->callid);
 		build_via(p);
 	}
 
@@ -6189,6 +6194,7 @@
 		p->ourip = __ourip;
 
 	p->branch = ast_random();
+	ast_log(LOG_DEBUG, "##### TEMP :: GENERATING NEW BRANCH TAG for call %s\n", callid);
 	make_our_tag(p->tag, sizeof(p->tag));
 	p->ocseq = INITIAL_CSEQ;
 
@@ -7195,12 +7201,13 @@
 	if (init) {		/* Seems like init always is 2 */
 		/* Bump branch even on initial requests */
 		p->branch ^= ast_random();
+		ast_log(LOG_DEBUG, "##### GENERATING NEW BRANCH TAG for call %s\n", p->callid);
 		p->invite_branch = p->branch;
 		build_via(p);
 		if (init > 1)
 			initreqprep(&req, p, sipmethod);
 		else
-			reqprep(&req, p, sipmethod, 0, 1);
+			reqprep(&req, p, sipmethod, 0, 0);	
 	} else
 		reqprep(&req, p, sipmethod, 0, 1);
 		
@@ -7970,6 +7977,7 @@
 	if (sipmethod == SIP_ACK)
 		p->invitestate = INV_CONFIRMED;
 
+	ast_log(LOG_DEBUG, "######## transmit_request newbranch %d method %s\n", newbranch, sip_methods[sipmethod].text);
 	reqprep(&resp, p, sipmethod, seqno, newbranch);
 	add_header_contentLength(&resp, 0);
 	return send_request(p, &resp, reliable, seqno ? seqno : p->ocseq);
